FCHMODAT(2)

NAME
fchmodat - change permissions of a file relative to a directory file descriptor

SYNOPSIS
#define _ATFILE_SOURCE
#include <sys/stat.h>

int fchmodat(int dirfd, const char *pathname, mode_t mode, int flags);

DESCRIPTION
The fchmodat() system call operates in exactly the same way as chmod(2), except for the differences described in this manual page. If the pathname given in pathname is relative, then it is interpreted relative to the directory referred to by the file descriptor dirfd (rather than relative to the current working directory of the calling process, as is done by chmod(2) for a relative pathname). If pathname is relative and dirfd is the special value AT_FDCWD, then pathname is interpreted relative to the current working directory of the calling process (like chmod(2)). If pathname is absolute, then dirfd is ignored. flags can either be 0, or include the following flag:

AT_SYMLINK_NOFOLLOW
    If pathname is a symbolic link, do not dereference it: instead operate on the link itself. This flag is not currently implemented.

RETURN VALUE
On success, fchmodat() returns 0. On error, -1 is returned and errno is set to indicate the error.

ERRORS
The same errors that occur for chmod(2) can also occur for fchmodat(). The following additional errors can occur for fchmodat():

EBADF
    dirfd is not a valid file descriptor.

EINVAL
    Invalid flag specified in flags.

ENOTDIR
    pathname is relative and dirfd is a file descriptor referring to a file other than a directory.

ENOTSUP
    flags specified AT_SYMLINK_NOFOLLOW, which is not supported.

VERSIONS
fchmodat() was added to Linux in kernel 2.6.16.

CONFORMING TO
This system call is non-standard but is proposed for inclusion in a future revision of POSIX.1.

NOTES
See openat(2) for an explanation of the need for fchmodat().

SEE ALSO
chmod(2), openat(2), path_resolution(7)